# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class AclBindingRule(pulumi.CustomResource):
    auth_method: pulumi.Output[str]
    """
    The name of the ACL auth method this rule apply.
    """
    bind_name: pulumi.Output[str]
    """
    The name to bind to a token at login-time.
    """
    bind_type: pulumi.Output[str]
    """
    Specifies the way the binding rule affects a token
    created at login.
    """
    description: pulumi.Output[str]
    """
    A free form human readable description of the
    binding rule.
    """
    selector: pulumi.Output[str]
    """
    The expression used to math this rule against valid
    identities returned from an auth method validation.
    """
    def __init__(__self__, resource_name, opts=None, auth_method=None, bind_name=None, bind_type=None, description=None, selector=None, __props__=None, __name__=None, __opts__=None):
        """
        Starting with Consul 1.5.0, the .AclBindingRule resource can be used to
        managed Consul ACL binding rules.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] auth_method: The name of the ACL auth method this rule apply.
        :param pulumi.Input[str] bind_name: The name to bind to a token at login-time.
        :param pulumi.Input[str] bind_type: Specifies the way the binding rule affects a token
               created at login.
        :param pulumi.Input[str] description: A free form human readable description of the
               binding rule.
        :param pulumi.Input[str] selector: The expression used to math this rule against valid
               identities returned from an auth method validation.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-consul/blob/master/website/docs/r/acl_binding_rule.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if auth_method is None:
                raise TypeError("Missing required property 'auth_method'")
            __props__['auth_method'] = auth_method
            if bind_name is None:
                raise TypeError("Missing required property 'bind_name'")
            __props__['bind_name'] = bind_name
            if bind_type is None:
                raise TypeError("Missing required property 'bind_type'")
            __props__['bind_type'] = bind_type
            __props__['description'] = description
            __props__['selector'] = selector
        super(AclBindingRule, __self__).__init__(
            'consul:index/aclBindingRule:AclBindingRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, auth_method=None, bind_name=None, bind_type=None, description=None, selector=None):
        """
        Get an existing AclBindingRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.
        
        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] auth_method: The name of the ACL auth method this rule apply.
        :param pulumi.Input[str] bind_name: The name to bind to a token at login-time.
        :param pulumi.Input[str] bind_type: Specifies the way the binding rule affects a token
               created at login.
        :param pulumi.Input[str] description: A free form human readable description of the
               binding rule.
        :param pulumi.Input[str] selector: The expression used to math this rule against valid
               identities returned from an auth method validation.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-consul/blob/master/website/docs/r/acl_binding_rule.html.markdown.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()
        __props__["auth_method"] = auth_method
        __props__["bind_name"] = bind_name
        __props__["bind_type"] = bind_type
        __props__["description"] = description
        __props__["selector"] = selector
        return AclBindingRule(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

